//==============================================================================
//	
//	Copyright (c) 2013-
//	Authors:
//	* Dave Parker <david.parker@comlab.ox.ac.uk> (University of Oxford)
//	* Mateusz Ujma <mateusz.ujma@cs.ox.ac.uk> (University of Oxford)
//	
//------------------------------------------------------------------------------
//	
//	This file is part of PRISM.
//	
//	PRISM is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//	
//	PRISM is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//	
//	You should have received a copy of the GNU General Public License
//	along with PRISM; if not, write to the Free Software Foundation,
//	Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//	
//==============================================================================

package heuristics.search;

import heuristics.ECContainer;
import heuristics.HeuristicsSMGModelChecker;
import heuristics.nextstate.HeuristicNextState;
import heuristics.update.StateUpdate;
import explicit.ModelExplorer;
import prism.PrismException;

public class HeuristicFactory
{
	public enum HeuristicType {
		RTDP, LBRTDP, BRTDP,BRTDP_BSCC;
		
		public static HeuristicType forName(String heuristicName, boolean bound) {
			if(bound) {
				if(heuristicName.equals("rtdp")) {
					return RTDP;
				} else {
					return LBRTDP;
				}
			} else {
				if (heuristicName.equals("brtdp_bscc")) return BRTDP_BSCC;
				else return BRTDP;
			}
		}	
	}
		
	public static Heuristic createHeuristic(HeuristicType type, HeuristicsSMGModelChecker mc, StateUpdate su, ECContainer eCC, HeuristicNextState nextState, ModelExplorer pme, boolean min, boolean collapseMECs) throws PrismException{
		switch(type) {
			case RTDP:
				return new HeuristicRTDP(mc, su, eCC, nextState, pme, min, collapseMECs);
			case LBRTDP:
				return new HeuristicLBRTDP(mc, su, eCC, nextState, pme, min, collapseMECs);
			case BRTDP:
				return new HeuristicBRTDP(mc, su, eCC, nextState, pme, min, collapseMECs);
			case BRTDP_BSCC:
				return new HeuristicBRTDP_BSCC(mc, su, eCC, nextState, pme, min, collapseMECs);
				
		}
		throw new PrismException("Unimplemented heuristic: " + type);
	}
}
